unit NEUnet;

interface

type
  Top = (_idle,_sbody,_body,_net);

  TshortStr= string[15];

  TcSource  = (_axon, _external);

  TneuronList= record
                name: TshortStr;
                id: word;
                next: pointer;
              end;

  TlinkedList= record
                 filename: string[8];
                 name: TshortStr;
                 val, step, min, max: single;
                 next: pointer;
               end;
  Tout = record
           filename: string[8];
           name: TshortStr;
           source: pointer;
           next: pointer;
         end;

  Tsynaps = record
              con: pointer; {connection to axon}
              w: single;
              src: TcSource; {axon or constant...}
            end;

  Tneuron = record
              id: word;
              nsy: byte;
              sy: array [0..15] of Tsynaps;
              axon: single;
              threshold: single;
              lambda: single;
              next: pointer;
            end;

var
  netFileName: string[12];
  netFile: text;
  netName: string[20];

  loading: boolean;
  nid, id: word; {#neurons -1)}
  nconst, nout: word;

  gmode: boolean;

  {----}
  {netsEnabled: boolean;}
  neuronList: ^TneuronList;
  neuron: ^Tneuron;
  linkedList: ^TlinkedList;
  out: ^Tout;
  lkotvicka: pointer; {list of neurons - name, id..}
  ckotvicka: pointer; {list of constants}
  nkotvicka: pointer; {neuron's net}
  lnkKotvicka: pointer;
  outKotvicka:pointer;
  currentNeuron, tmpPtr: pointer;

  {-------------}
  procedure netIt;
  procedure haltNet;
  procedure writeNeuList;
  procedure writeNeuDat(nn: TshortStr);
  procedure nCSC(nn: TshortStr;synaps:byte;newV:single);
  procedure nCLB(nn: TshortStr;newV:single);
  procedure nCTH(nn: TshortStr;newV:single);
  procedure writeOut;
  procedure writeLinked;
  procedure countIt;
  procedure modifyInput(n:TshortStr;nval:single);
  procedure modifyMin(n:TshortStr;nval:single);
  procedure modifyMax(n:TshortStr;nval:single);
  procedure modifyStep(n:TshortStr;nval:single);
  procedure storeNet(fileName:TshortStr);
  procedure storeLinked(fileName: TshortStr);
  function searchNeuron(id: word):pointer;
  procedure IERRO;
  function searchNameInList(idx:word):pointer;



implementation

{error end - invalid op-code}

const
  cmdChSet=[];
  divChSet=[' ',','];
  maxsp=4;
  spacLen=15; {space for synaps syntax used in STOREnet}
  _stepDEF= 0.05;
  _minDEF=-5;
  _maxDEF=5;

var
  op: array [0..3] of Top; {8- level deep stack of operation}
  sp: byte; {stack pointer}
  opstr,instr, netPokec, sacc1, sacc2 : string;
  cSource: TcSource;
  charset: byte;
  nline: longint;
  valop: boolean;


procedure odmazMezirky(var instr: string);
begin
  while ((instr[1]<#33) or (instr[1]>#250)) and (length(instr)>0) do {odmazani mezer....}
      delete(instr,1,1);
end;

procedure PEC;
begin
  writeln('press enter to continue...');
  readln;
end;


function isin(var instr: string; str: string; del: boolean): boolean;
var
  i:byte;
  ok: boolean;
begin
  i:=1;
  ok:= true;
  if length(instr)<length(str) then ok:= false
  else
    while (i<length(instr)) and (i<length(str)) do begin
      if str[i]<>instr[i] then ok:= false;
      inc(i);
    end;
  isin:= ok;
  if del and ok then
    delete(instr, 1, i);
end;

procedure getStr(var str:string);
var
  i:byte;
begin
  i:=1;
  while (str[i]<>';') and (i<length(str)) do
    inc(i);
  if i<255 then
    str:= copy(str, 1, i);
end;

procedure getNewName(var str: string);
var
  i: byte;
begin
  i:=1;
  while (length(str)>i) and (str[i]<>' ') do
    inc(i);
  if str[i]=' ' then
    str:= copy(str, 2, (i-2))
  else
    str:='';
end;

procedure addNewName(var _name: string; _id:word);
var
  tmp_nl: ^TneuronList;
  p:pointer;
begin
{  writeln('allocating memory for neuron''s list:  ID:',_id,' name:',_name);}
  p:=neuronList; {save pointer - tady nevim jak to napsat aby se predal}
  tmp_nl:=p;    {pouze pointer - nechape kdyz napisu tmp_nl:=neuronList, debil jeden!}
  new(neuronList); {allocate new}
  if _id=0 then lkotvicka:=neuronList;
  tmp_nl^.next:= neuronList; {send "pred" pointer}
  with neuronList^ do begin {new values}
    name:= _name;
    id:= _id;
    next:= lkotvicka;
  end;
end;

procedure addNeuron(_id:word);
var
  tmp_n: ^Tneuron;
  p:pointer;
begin
{  writeln('allocating memory neuron:  ID:',_id);}
  p:=neuron; {save pointer - tady nevim jak to napsat aby se predal}
  tmp_n:=p;    {pouze pointer - nechape kdyz napisu tmp_n:=neuron, debil jeden!}
  new(neuron); {allocate new}
  if _id=0 then nkotvicka:=neuron;
  if _id>0 then tmp_n^.next:= neuron; {send "pred" pointer}
  with neuron^ do begin {new values}
    id:= _id;
    nsy:= 0;
    next:= nkotvicka;
  end;
end;

procedure addConst(c: single;_file, _name: string);
var
  tmp_lnk: ^TlinkedList;
  p:pointer;
begin
{  writeln('allocating memory for const- file:',_file,' name:',_name);}
  p:=linkedList; {save pointer}
  tmp_lnk:=p;
  new(linkedList); {allocate new}
  if nconst=0 then lnkKotvicka:=linkedList;
  if nconst>0 then tmp_lnk^.next:= linkedList; {send "pred" pointer}
  with linkedList^ do begin {new values}
    name:= _name;
    val:= c;
    step:= _stepDEF;
    min:= _minDEF;
    max:= _maxDEF;
    fileName:= _file;
    next:= lnkKotvicka;
  end;
  inc(nconst);
end;

procedure addOut(_file, _name: string);
var
  tmp_out: ^Tout;
  p:pointer;
begin

  p:=out; {save pointer}
  tmp_out:=p;
  new(out); {allocate new}
  if nout=0 then outKotvicka:=out;
  if nout>0 then tmp_out^.next:= out; {send "pred" pointer}
  with out^ do begin {new values}
    name:= _name;
    fileName:= _file;
    next:= outKotvicka;
  end;
  inc(nout);
  writeln('output added: file:',_file,' name:',_name);
end;


procedure freeMemory;
var
  i: word;
  next_nl, next_n, next_lnk, next_out: pointer;
begin
  for i:=nid downto 1 do begin
    next_nl:= neuronList^.next;
    next_n:= neuron^.next;
   { with neuronList^ do
      writeln('...freeing memory from neuron list:  ID:',id,' with name:',name,' /total neurons: ',nid);
    with neuron^ do
      writeln('...freeing memory from neuron:  ID:',id);}
    dispose(neuronList);
    dispose(neuron);
    dec(nid);
   { writeln(' > succesfully DONE.');}
    neuronList:= next_nl;
    neuron:= next_n;
  end;
  for i:=nconst downto 1 do begin
    next_lnk:= linkedList^.next;
    dispose(linkedList);
{    writeln('freeing const#',nconst);}
    dec(nconst);
    linkedList:=next_lnk;
  end;
  linkedList:= nil;
  for i:=nout downto 1 do begin
    next_out:= out^.next;
    dispose(out);
{    writeln('freeing output#',nout);}
    dec(nout);
    out:=next_out;
  end;
  out:= nil;
end;

function searchNeuronInList(name: string): word;
var
  i: word;
  ok: boolean;
begin
  ok:= false;
  searchNeuronInList:= $FFFF;
  for i:= nid downto 1 do begin {browsing the neural list}
    if neuronList^.name = name then begin
      ok:= true;
      break;
    end;
    neuronList:=neuronList^.next;
  end;
  if ok then searchNeuronInList:= neuronList^.id
end;

function searchInput(n:TshortStr):pointer;
var
  i: word;
begin
  searchInput:= nil;
  for i:=1 to nconst do begin
    if linkedList^.name=n then begin
      searchInput:= linkedList;
      break;
    end;
  end;
end;


function searchNeuron(id: word):pointer;
var
  i: word;
  ok: boolean;
  storeneuron: pointer;
begin
  searchNeuron:= nil;
  storeNeuron:= neuron;
  for i:= nid downto 1 do begin {browsing the neural net}
    if neuron^.id = id then begin
      ok:= true;
      break;
    end;
    neuron:=neuron^.next;
  end;
  if ok then searchNeuron:= neuron;
  neuron:= storeneuron;{?}
end;

procedure getFile(var s: string);
begin
  s:= s+' ';
  s:= copy(s, pos('#', s)+1, pos('.', s)-pos('#', s)-1);
end;

procedure getName(var s: string);
begin
  s:= s+' ';
  s:= copy(s, pos('.', s)+1, pos(' ', s)-pos('.', s)-1);
end;

function loadFloat(var s: string): single;
var
  str: string[20];
  code: integer;
  outv: single;
  len: byte;
  fileName: string;
  sConst, lnk, tmp: string;
  f: text;
  found: boolean;

begin
  if s[1] in ['0'..'9','-'] then begin
    len:= length(s);
    str:= copy(s, 1, len);
    val(str, outv, code);
    delete(s, 1, len);
  end
  else
    if s[1] = '#' then begin
     fileName:= s;
     sConst:= s;
     getFile(fileName);
     fileName:= fileName + '.lnk';
     getName(sConst);
     {$I-}
     assign(f, fileName);
     reset(f);
     found:= false;
     if IOResult=0 then begin
       while not eof(f) do begin
         readln(f, lnk);
         odmazMezirky(lnk);
         tmp:= copy(lnk, 1, pos('=',lnk)-1);
         if tmp=sConst then begin
           delete(lnk, 1, pos('=', lnk));
           odmazMezirky(lnk); lnk:= lnk + ' ';
           lnk:= copy(lnk, 1, pos(' ',lnk)-1);
           val(lnk, outv, code);
           if code<>0 then begin
             writeln('! there is an error in Float string!: ', fileName);
             readln;
           end;
           found:= true;
           break;
         end
       end;
       if not found then writeln('! invalid input-linked list name: ',fileName);
       close(f);
     end
     else begin
       writeln('! file ', fileName + ' not eXist!, press ENTER to cont.');
       readln;
     end;

     {$I+}
    end;
  loadFloat:= outv;
end;


function getSyNum(var s: string): byte;
var
  outv: word;
  str: string;
  code: integer;
begin
  s:= s + ' ';
  str:= copy(s, pos('.',s)+1, pos(' ',s)-pos('.',s)-1);
  val(str, outv, code);
  if code<>0 then
    writeln('integer error (synaps#) at:',code);
  getSyNum:= outv;
end;

procedure IERRO;
begin
  writeln('I''m sorry but every program has a holes:');
  writeln('Internal error occurs. Please restart your computer or quit this program immediately!!! (q)');
  writeln('press enter to continue and then type ''q'' and press enter! + reboot');
  readln;
end;

procedure II; {invalid identifier}
begin
  writeln('Identifier not found!');
end;

function divch(s: string):byte;
var
  i,l:byte;
begin
  l:= length(s);
  divch:=0;
  for i:=1 to l do begin
    if s[i] in cmdChSet then begin
      divch:= i;
      break;
    end;
    if s[i] in divChSet then begin
      divch:= i;
      break;
    end;
  end;
end;

procedure netIt;
label errend, skipall;
var
  currsy: byte;
begin
  {$I-}
  assign(netFile, netFileName);
  reset(netFile);
  writeln('loading neuron-network data...');
  if IOResult<>0 then begin
    writeln('file: ',netFilename,' not exist, or disk error occurs.');
    halt(1);
  end;
  {$I+}
  nline:=0;
  loading:= false;
  nid:= 0;
  nout:=0;
  nconst:=0;
  cSource:= _axon;
  out:= nil;
  linkedList:= nil;

  {*** building neurons ***}
  while not eof(netFile) do begin
    readln(netFile, instr);
    odmazMezirky(instr);
    inc(nline);
    if length(instr)>1 then begin
      case instr[1] of
       '/': begin
              valop:= false;
             {meno site}
            if isin(instr, '/netname/', true) then begin
              odmazMezirky(instr);
              getStr(instr);
              netName:= instr;
              valop:= true;
              writeln('net''s name found:',netName);
            end;
            {pokec}
            if isin(instr, '/pokec/', true) then begin
              odmazMezirky(instr);
              getStr(instr);
              netPokec:= instr;
              valop:= true;
              writeln('net''s pokec found:',netPokec);
            end;
            {net}
            if isin(instr, '/net/', true) then begin
              odmazMezirky(instr);
              getStr(instr);
              valop:= true;
              writeln('neuron-network data found...loading');
              loading:= true;
            end;
          end;
       '<': begin if loading then begin
              getNewName(instr);
              if instr='' then begin
                writeln('invalid neuron name: ',nline);
                freeMemory;
                halt(1);
              end;
              if length(instr)>15 then begin
                writeln('neuron''s name too long (max.15 char)! ',nline);
                freeMemory;
                halt(1);
              end;
              writeln(' > new neuron added with ID: ',nid,': ',instr);
              if searchNeuronInList(instr)<>$FFFF then begin
                writeln('neuron name duplicated! ',nline);
                freeMemory;
                halt(1);
              end;
              addNewName(instr, nid);
              addNeuron(nid);
              inc(nid);
            end
              else begin
                writeln('error: type "/net/" before typing net''s "circuitry"');
                halt(1);
              end;
            end;
       ';': begin
              instr:= '';
              valop:= true;
            end;
      end;
        if not valop then begin
          writeln('error at ln:',nline,' - invalid op-code!');
          halt(1);
        end;
      end;
    end;
  {*** building neural net ***}
  close(netFile); {sets file pointer to 0}
  reset(netFile);
  nline:=0;
  {netsEnabled:= false;}
  sp:=0;

  while not eof(netFile) do begin
    readln(netFile, instr);
    inc(nline);
    odmazMezirky(instr);
    instr:= instr + ' ';
    while length(instr)>0 do begin
      odmazMezirky(instr);
      opstr:= copy(instr,1,divch(instr)-1);
      delete(instr,1,divch(instr));
{      writeln('STATUS:',instr);}
      if length(opstr)>0 then begin
      case opstr[1] of
        '{':begin
              if op[sp]=_body then begin
                delete(opstr,1,1);
                inc(sp);
                op[sp]:= _net;
              end
              else begin
                writeln('{'' before specifing neuron body: <...> :',nline);
                freeMemory;
                goto errend;
              end;
            end;
        '}':begin
              delete(opstr,1,1);
              if sp<1 then begin
                writeln('command stack underflow:',sp,' at:',nline);
                  freeMemory;
                  goto errend;
                end;
              dec(sp);
            end;
        '<':begin
              if op[sp]=_sbody then begin
                writeln('''<'' found (>1):',nline);
                freeMemory;
                goto errend;
              end;
              delete(opstr,1,1);
              inc(sp);
              if sp> maxsp then begin
                writeln('command stack overflow:',sp,' at:',nline);
                  freeMemory;
                  goto errend;
                end;
              op[sp]:= _sbody;
            end;
        '>':begin
              delete(opstr,1,1);
              if sp<1 then begin
                writeln('command stack underflow:',sp,' at:',nline);
                  freeMemory;
                  goto errend;
                end;
              dec(sp);
            end;
        '^':begin {LAMBDA}
              if op[sp]=_body then begin
                delete(opstr,1,1);
                neuron^.lambda:= loadFloat(opstr);
              end
              else begin
                writeln('lamba definition before specifing neuron name: body:',nline);
                freeMemory;
                goto errend;
              end;
            end;
        '&':begin {THRESHOLD}
              if op[sp]=_body then begin
                delete(opstr,1,1);
                neuron^.threshold:= loadFloat(opstr);
              end
              else begin
                writeln('threshold definition before specifing neuron name: body:',nline);
                freeMemory;
                goto errend;
              end;
            end;
        '#':begin
              if op[sp]=_net then begin
                sacc1:= opstr; getFile(sacc1);
                sacc2:= opstr; getName(sacc2);
                tmpPtr:= searchInput(sacc2);
                if tmpPtr=nil then begin
                  addConst(loadFloat(opstr), sacc1, sacc2); {set linkedList to current ptr}
                  cSource:= _external;
                  tmpPtr:= linkedList;
                end;
              end
              else begin
                writeln('''#'' direcive found before spec. synaps connection ({):',nline);
                freeMemory;
                goto errend;
              end
            end;
        '$':begin
              if op[sp]=_net then begin
                delete(opstr,1,1);
                neuron^.sy[neuron^.nsy-1].w:= loadFloat(opstr);
              end;
            end;
        ';':begin
              opstr:='';
              instr:='';
              goto skipall;
            end;

        '/':begin
              opstr:='';
              instr:='';
              goto skipall;
            end;
      end;

      odmazMezirky(opstr);
      if op[sp]=_sbody then begin
        id:= searchNeuronInList(opstr); {set PTR to current neuron - in list}
        if id=$FFFF then begin
          writeln('internal error ocuurs: neuron not in list or >1 name of neuron specified:',nline);
          freeMemory;
          goto errend;
        end;
        neuron:= searchNeuron(id); {set PTR to current neuron}
        if neuron=nil then begin
          IERRO;
          neuron:=nKotvicka; {zachrana proti totalnimu krachu :)}
        end;
        op[sp]:= _body;
      end;
      if op[sp]= _net then begin
        if (opstr[1]='a') and (opstr[2]='x') and (opstr[3]='#') then begin
          sacc1:= opstr; getFile(sacc1);
          sacc2:= opstr; getName(sacc2);
          addOut(sacc1, sacc2);
          out^.source:= neuron; {put source ptr}
        end;
        if (opstr[1]='s') and (opstr[2]='y') then begin
          currsy:=getSyNum(opstr);
          if currsy<>neuron^.nsy then begin
            writeln('warning: synaps order error, use sy.0->sy.15!: ',nline);
          end;
          neuron^.sy[currsy].con:=tmpPtr; {make connection}
          neuron^.sy[currsy].src:= cSource;
          inc(neuron^.nsy);
        end;
        if (opstr[1]='a') and (opstr[2]='x') and (opstr[3]='.')then begin
          sacc1:= opstr; getName(sacc1);
          id:= searchNeuronInList(sacc1);
          if id=$FFFF then begin
            writeln('unknown neuron name [',sacc1,']: ',nline);
            freeMemory;
            goto errend;
          end;
          tmpPtr:= searchNeuron(id); {save pointer to axon }
          cSource:= _axon;
        end;
      end;
      end;
    end;
    skipall:
  end;
  writeln('meno site:',netName);
  writeln('pokec:', netPokec);
  errend:
  close(netFile);
end;

procedure haltNet;
begin
  freeMemory;
  writeln('cau, contactiky: http://asyncbrain.baf.cz , email: jense@seznam.cz');
end;

procedure writeMemLoc(meml:pointer);
begin
  writeln('mem location: #',((longint(meml)) shr 2) and $0000FFFF ,':#',longint(meml) and $0000FFFF);
end;

procedure writeNeuList;
var
  i: word;
begin
  neuronList:= lkotvicka;
  writeln('listing of neunet');
  for i:=1 to nid do begin
    writeln('NET: ID=',neuronList^.id,' NAME:',neuronList^.name);
    if (i mod 20)=0 then PEC;
    neuronList:=neuronList^.next;
  end;
end;

procedure writeLinked;
var
  i: word;
begin
  linkedList:= lnkKotvicka;
  writeln('listing of linked (external) constants:');
  for i:=1 to nconst do begin
    with linkedList^ do
      writeln('LNK:  FILE:',fileName,' NAME:',name,' VAL:',val:8:4, ' STEP:',step:8:4,' MIN:',min:8:4,' MAX:',max:8:4);
    if (i mod 20)=0 then PEC;
    linkedList:=linkedList^.next;
  end;
end;

procedure writeOut;
var
  i: word;
begin
  out:= outKotvicka;
  writeln('listing of output:');
  for i:=1 to nout do begin
    neuron:= out^.source;
    writeln('OUT:  FILE:',out^.fileName,' NAME:',out^.name,' SOURCE:',neuron^.id);
    if (i mod 20)=0 then PEC;
    out:=out^.next;
  end;
end;


procedure nCSC(nn: TshortStr;synaps:byte;newV:single);
var
  neurId: word;
begin
  neurId:=searchNeuronInList(nn);
  if neurId<$FFFF then begin
    writeln('NET: neuron name= ',nn,' ID:',neurId);
    neuron:= searchNeuron(neurId);
    writeMemLoc(neuron);
    if (synaps<neuron^.nsy) and (synaps>=0) then begin
      neuron^.sy[synaps].w:= newV;
      writeln('NET: neuron''s synaps /',nn,' #',synaps,' got new W coef:',neuron^.sy[synaps].w);
    end
    else
      writeln('synaps # out of range, #synaps:',neuron^.nsy);
  end
  else
    writeln('no such neuron name found.');
end;

procedure nCLB(nn: TshortStr;newV:single);
var
  neurId: word;
begin
  neurId:=searchNeuronInList(nn);
  if neurId<$FFFF then begin
    writeln('NET: neuron name= ',nn,' ID:',neurId);
    neuron:= searchNeuron(neurId);
    writeMemLoc(neuron);
    neuron^.lambda:= newV;
    writeln('new lamba established:',neuron^.lambda:8:4);
  end
  else
    writeln('no such neuron name found.');
end;


procedure nCTH(nn: TshortStr;newV:single);
var
  neurId: word;
begin
  neurId:=searchNeuronInList(nn);
  if neurId<$FFFF then begin
    writeln('NET: neuron name= ',nn,' ID:',neurId);
    neuron:= searchNeuron(neurId);
    writeMemLoc(neuron);
    neuron^.threshold:= newV;
    writeln('new threshold established:',neuron^.threshold:8:4);
  end
  else
    writeln('no such neuron name found.');
end;


procedure writeNeuDat(nn: TshortStr);
var
  neurId: word;
  src: TshortStr;
  i: byte;
begin
  neurId:=searchNeuronInList(nn);
  if neurId<$FFFF then begin
    neuron:= searchNeuron(neurId);
    writeln('Neuron name= ',nn,' ID:',neurId);
    writeln('lambda:',neuron^.lambda:8:4);
    writeln('threshold:',neuron^.threshold:8:4);
    writeln('current axon''s value:',neuron^.axon:8:4);
    writeln('#synaps:',neuron^.nsy);
    {!synaps sources....}
    for i:=0 to neuron^.nsy-1 do begin
      case neuron^.sy[i].src of
        _axon: src:='axon';
        _external: src:='external';
      end;
      writeln('SYNAPS #',i,' W:',neuron^.sy[i].w:8:4,' SOURCE: ',src);
    end;
    writeMemLoc(neuron);
  end
  else
    writeln('no such neuron name found.');
end;

procedure countIt;
var
  ksi,x: single;
  ni: word;
  i:byte;
  tmpneur: ^Tneuron;
  tmpLnk: ^TlinkedList;
begin
  if not gmode then writeln('counting NeuNet... (*=1neuron done)');
  neuron:= nKotvicka;
  for ni:=1 to nid do begin
    ksi:=0;
    for i:=1 to neuron^.nsy do begin
      case neuron^.sy[i-1].src of {get X - input}
        _axon:    begin
                    tmpneur:=neuron^.sy[i-1].con;
                    x:= tmpneur^.axon;
                  end;
        _external:begin
                    tmpLnk:= neuron^.sy[i-1].con;
                    x:= tmpLnk^.val;
                  end;
      end;
      ksi:= ksi + (x*neuron^.sy[i-1].w); {sum of XjWj}
    end;
    ksi:= ksi - neuron^.threshold; {-treshold}
    {--sigmoid.FCE--}
    neuron^.axon:= 1/(1+exp((-1)*neuron^.lambda*ksi));
    neuron:= neuron^.next; {count next}
    if not gmode then write('*');
  end;
  if not gmode then begin
    writeln('');
    writeln('done.');
  end;
end;


procedure modifyInput(n:TshortStr;nval:single);
var
  xinput: ^TlinkedList;
begin
  xinput:=searchInput(n);
  if xinput=nil then II
  else begin
    xinput^.val:= nval;
    writeln('new value established to ',n,' input: ', xinput^.val:8:4);
  end;
end;

procedure modifyStep(n:TshortStr;nval:single);
var
  xinput: ^TlinkedList;
begin
  xinput:=searchInput(n);
  if xinput=nil then II
  else begin
    xinput^.step:= nval;
    writeln('new value established to ',n,' step: ', xinput^.step:8:4);
  end;
end;

procedure modifyMin(n:TshortStr;nval:single);
var
  xinput: ^TlinkedList;
begin
  xinput:=searchInput(n);
  if xinput=nil then II
  else begin
    xinput^.min:= nval;
    writeln('new value established to ',n,' min_val: ', xinput^.min:8:4);
  end;
end;

procedure modifyMax(n:TshortStr;nval:single);
var
  xinput: ^TlinkedList;
begin
  xinput:=searchInput(n);
  if xinput=nil then II
  else begin
    xinput^.max:= nval;
    writeln('new value established to ',n,' max_val: ', xinput^.max:8:4);
  end;
end;



procedure addSpaces(var s: string);
begin
  while length(s)<spacLen do s:= s + ' ';
end;

function searchNameInList(idx:word):pointer; {ser. neuron name by ID}
var
  i:word;
  neurLs: ^TneuronList;
begin
  searchNameInList:= nil;
  neurLs:= lKotvicka;
  for i:=1 to nid do begin
    if neurLs^.id=idx then begin
      searchNameInList:= neurLs;
      break;
    end;
    neurLs:= neurLs^.next;
  end;
end;

procedure storeNet(fileName:TshortStr);
var
  f: text;
  s: string;
  ms: string;
  ss: TshortStr;
  tmpn: ^Tneuron;
  tmpl: ^TneuronList;
  tmpc: ^TlinkedList;
  i, oi:word;
  si:byte;
begin
  writeln('saving NeuNet to: ',fileName,'  ''*''=1neuron saved');
  s:='';
  {$I-}
  assign(f,fileName);
  rewrite(f);
  if IOResult<>0 then
    writeln('file can''t be created. :-(')
  else begin
    writeln(f,';*** Created by Synthetic Neural Network: developed by http://asyncbrain.baf.cz ***');
    writeln(f,';SynthNeuNet CODE:');
    writeln(f,'');
    writeln(f,';ABOUT THIS NEUNET:');
    writeln(f,'/pokec/',netPokec);
    writeln(f,';NAME:');
    writeln(f,'/netname/',netName);
    writeln(f,';-------------------');
    writeln(f,'');
    writeln(f,';NEURAL NET:');
    writeln(f,'/net/');
    neuronList:= lKotvicka;
    for i:=1 to nid do begin
      writeln(f,'');
      writeln(f,';-----------------------------------');
      neuron:= searchNeuron(neuronList^.id);

      str(neuron^.lambda:8:4, ms);
      odmazMezirky(ms);
      {header of neuron}
      s:= '<'+neuronList^.name+' ^'+ms;
      str(neuron^.threshold:8:4, ms);
      odmazMezirky(ms);
      s:= s+' &'+ms+'    ;name: '+neuronList^.name+'  ID:';
      str(neuron^.id,ms);
      odmazMezirky(ms);
      s:= s+ ms;
      writeln(f,s);
      writeln(f,'{');
      for si:=0 to neuron^.nsy-1 do begin
        case neuron^.sy[si].src of
          _axon:     begin {AXON connection}
                       tmpn:= neuron^.sy[si].con;
                       tmpl:= searchNameInList(tmpn^.id);
                       if tmpl=nil then IERRO;
                       s:= 'ax.'+tmpl^.name;
                     end;

          _external: begin {EXTERNAL connection}
                       tmpc:= neuron^.sy[si].con;
                       s:= '#'+tmpc^.fileName+'.'+tmpc^.name;
                     end;
        end;
        addSpaces(s);
        s:= s + 'sy.';
        str(si, ss);
        s:= s + ss + '   $';
        str(neuron^.sy[si].w:8:4, ms);
        odmazMezirky(ms);
        s:= s+ms;
        writeln(f, s);
      end;
      for oi:=1 to nout do begin
        if out^.source = neuron then begin
          writeln(f, 'ax#'+out^.fileName+'.'+out^.name);
        end;
      end;
      writeln(f, '} >');
      neuronList:=neuronList^.next;
      write('*');
    end;
  end;
  {I-}
  close(f);
  {I+}
  if IOResult<>0 then writeln('I/O error occurs.');
end;

procedure storeLinked(fileName: TshortStr);
var
  f: text;
  cv: TshortStr;
  tmpi: ^Tlinkedlist;
  i: word;
begin
  writeln('saving linked inputs to: ',fileName,'  ''*''=1input saved');
  {$I-}
  fileName:='';
  tmpi:= lnkKotvicka;

  {takhle je to udelany kvuli neomezenemu poctu linkovych souboru :-) tj. anti-Billova deformace}
  for i:=1 to nconst do begin
    if fileName<>tmpi^.fileName then begin
      fileName:=tmpi^.fileName;
      assign(f,fileName);
      rewrite(f);
      if IOResult<>0 then
        writeln('file can''t be created. :-(');
      close(f);
    end;
  end;
  fileName:= '';
  for i:=1 to nconst do begin
    if fileName<>tmpi^.fileName then begin
      close(f);
      fileName:=tmpi^.fileName;
      assign(f,fileName);
      append(f);
      if IOResult<>0 then
        writeln('file can''t be created. :-(')
    end;
    str(tmpi^.val:8:4, cv);
    writeln(tmpi^.name,'=',cv);
  end;
end;



{
********************************************************************
 NEURAL COMPUTER  NEURAL COMPUTER  NEURAL COMPUTER  NEURAL COMPUTER
********************************************************************
}



end.