unit cmdLn;

interface

type
  TshortStr=string[20];
  Tcmd=(_none,_help,_m8,_m14,_m16,_exit,_s,_l,_t,_maxin,_minin,
        _cstep,_g,_last,_rel,_neul,_nr,_ils,_ols,_cit,_cin,_sto,
        _cmax,_cmin,_fgen,_fgc,_agen,_agc);

var
  xreal: array[0..3] of single;
  xint:  array[0..3] of integer;
  xstr:  array[0..3] of TshortStr;
  c, oldc:Tcmd;

procedure cmd(cs:string);

implementation

type
  Tpcmd=(none, OK);

const
  maxBuf=7;

var
  cmdCont: array[0..maxBuf] of TshortStr;
  cmdStr: string;
  contInx: byte; {#paramstringu}
  pcmd: Tpcmd;
  err: integer;

procedure odmazMezirky(var instr: string);
begin
  while (instr[1]=#32) and (length(instr)>0) do {odmazani mezer....}
      delete(instr,1,1);
end;

procedure cutIt;
var
  i:byte;
begin
  cmdStr:= cmdStr + ' ';
  contInx:= 0;
  for i:=0 to 7 do
    cmdCont[i]:= '';
  while length(cmdStr)>0 do begin
    odmazMezirky(cmdStr);
    cmdCont[contInx]:=copy(cmdStr,1,pos(' ',cmdStr)-1);
    delete(cmdStr,1,pos(' ',cmdStr));
    inc(contInx);
  end;
end;

function cmdOK(nparam:byte):boolean;
var
  i:byte;
begin
  cmdOK:= true;
  for i:=0 to nparam-1 do
    if cmdCont[i]='' then begin
      cmdOK:= false;
      writeln('noe enough actual parameters! try ''help''');
      break;
    end;
end;

procedure cmd(cs:string);
var
  i:byte;
begin
  {clear command buffers}
  for i:=0 to maxBuf do
    cmdCont[i]:='';

  cmdStr:= cs;
  cutIt;
  pcmd:=none;
  c:=_none;
  err:= 0;
  if (cmdCont[0] = 'help') or (cmdCont[0] = 'ls') then begin
    c:= _help;
    xstr[0]:=cmdCont[1];
    pcmd:=OK;
  end;
  if (cmdCont[0] = 'exit') or (cmdCont[0] = 'q') then begin
    c:= _exit;
    pcmd:=OK;
  end;
  if cmdCont[0] = '8x8' then begin
    c:= _m8;
    pcmd:=OK;
  end;
  if cmdCont[0] = '8x14' then begin
    c:= _m14;
    pcmd:=OK;
  end;
  if cmdCont[0] = '8x16' then begin
    c:= _m16;
    pcmd:=OK;
  end;
  if cmdCont[0] = 'csc' then begin
    xstr[0]:= cmdCont[1];
    if cmdOK(4) then begin
      val(cmdCont[2], xint[0], err);
      if err=0 then begin
        val(cmdCont[3], xreal[0], err);
        if err=0 then begin
          pcmd:=OK;
          c:= _s;
        end;
      end;
    end;
  end;
  if cmdCont[0] = 'clb' then begin
    if cmdOK(3) then begin
      xstr[0]:= cmdCont[1];
      val(cmdCont[2], xreal[0], err);
      if err=0 then begin
        pcmd:=OK;
        c:= _l;
      end;
    end;
  end;
  if cmdCont[0] = 'cth' then begin
    if cmdOK(3) then begin
      xstr[0]:= cmdCont[1];
      val(cmdCont[2], xreal[0], err);
      if err=0 then begin
        pcmd:=OK;
        c:= _t;
      end;
    end;
  end;
  if cmdCont[0] = 'cin' then begin
    if cmdOK(3) then begin
      xstr[0]:= cmdCont[1];
      val(cmdCont[2], xreal[0], err);
      if err=0 then begin
        pcmd:=OK;
        c:= _cin;
      end;
    end;
  end;
  if cmdCont[0] = 'cstep' then begin
    if cmdOK(3) then begin
      xstr[0]:= cmdCont[1];
      val(cmdCont[2], xreal[0], err);
      if err=0 then begin
        pcmd:=OK;
        c:= _cstep;
      end;
    end;
  end;
  if cmdCont[0] = 'cmax' then begin
    if cmdOK(3) then begin
      xstr[0]:= cmdCont[1];
      val(cmdCont[2], xreal[0], err);
      if err=0 then begin
        pcmd:=OK;
        c:= _cmax;
      end;
    end;
  end;
  if cmdCont[0] = 'cmin' then begin
    if cmdOK(3) then begin
      xstr[0]:= cmdCont[1];
      val(cmdCont[2], xreal[0], err);
      if err=0 then begin
        pcmd:=OK;
        c:= _cmin;
      end;
    end;
  end;
  if cmdCont[0] = 'maxin' then begin
    if cmdOK(3) then begin
      xstr[0]:= cmdCont[1];
      val(cmdCont[2], xreal[0], err);
      if err=0 then begin
        pcmd:=OK;
        c:= _maxin;
      end;
    end;
  end;
  if cmdCont[0] = 'minin' then begin
    xstr[0]:= cmdCont[1];
    val(cmdCont[2], xreal[0], err);
    if err=0 then begin
      pcmd:=OK;
      c:= _minin;
    end;
  end;
  if cmdCont[0] = 'step' then begin
    val(cmdCont[1], xreal[0], err);
    if err=0 then begin
      pcmd:=OK;
      c:= _cstep;
    end;
  end;
  if cmdCont[0] = 'nls' then begin
    c:= _neul;
    pcmd:=OK;
  end;
  if cmdCont[0] = 'ols' then begin
    c:= _ols;
    pcmd:=OK;
  end;
  if cmdCont[0] = 'ils' then begin
    c:= _ils;
    pcmd:=OK;
  end;
  if cmdCont[0] = 'cit' then begin
    val(cmdCont[1],xint[0],err);
    if (err=0) then begin
       c:= _cit;
       pcmd:=OK;
    end;
    if (cmdCont[1]='') then begin
      xint[0]:=1;
      c:= _cit;
      pcmd:=OK;
    end;
  end;
  if cmdCont[0] = 'nr' then begin
    xstr[0]:= cmdCont[1];
    c:= _nr;
    pcmd:=OK;
  end;

  if cmdCont[0] = 'g' then begin
    c:= _g;
    pcmd:=OK;
  end;
  if cmdCont[0] = 'l' then begin
    c:= oldc;
    pcmd:=OK;
  end;
  if cmdCont[0] = 'rel' then begin
    c:= _rel;
    pcmd:=OK;
  end;
  if cmdCont[0] = 'store' then begin
    if cmdOk(2) then begin
      xstr[0]:= cmdCont[1];
      pcmd:=OK;
      c:= _sto;
    end;
  end;
  if cmdCont[0] = 'fg' then begin
    val(cmdCont[1],xint[0],err);
    if (err=0) then begin
       c:= _fgen;
       pcmd:=OK;
    end;
    if (cmdCont[1]='') then begin
      xint[0]:=1;
      c:= _fgen;
      pcmd:=OK;
    end;
  end;
  if cmdCont[0] = 'ag' then begin
    val(cmdCont[1],xint[0],err);
    if (err=0) then begin
       c:= _agen;
       pcmd:=OK;
    end;
    if (cmdCont[1]='') then begin
      xint[0]:=1;
      c:= _agen;
      pcmd:=OK;
    end;
  end;
  if cmdCont[0] = 'fgc' then begin
    if cmdOK(2) then begin
      val(cmdCont[1], xreal[0], err);
      if err=0 then begin
        pcmd:=OK;
        c:= _fgc;
      end;
    end;
  end;
  if cmdCont[0] = 'agc' then begin
    if cmdOK(2) then begin
      val(cmdCont[1], xreal[0], err);
      if err=0 then begin
        pcmd:=OK;
        c:= _agc;
      end;
    end;
  end;
  if (pcmd=none) and (length(cmdCont[0])>0) then writeln('unknown command or error at:',err,' , try ''help''.');
  oldc:= c;
end;

end.